#include "mmGlobal.h"
#include "mmData.h"

#define BLOCK_SIZE 100


PLOT_DATA *MM_InitData (void)
{
  int        count;
  PLOT_DATA *Result;

  Result = (PLOT_DATA*)malloc(sizeof(PLOT_DATA));

  Result->actual = -1;
  Result->Number = 0;
  for (count = 0; count < 255; ++count)
    Result->Line[count] = NULL;

  return Result;
}


int MM_AddData (PLOT_DATA *Data, char *Name, int Color, int Mode)
{
  int Number;

  PRO_START ("["__FUNCTION__"]...")

  if (Data == NULL || 
      (Number = Data->Number) > 255 || Data->Line[Number] != NULL)
    PRO_RETURN ("Invalid Data", -1)

  Data->actual = Number;

  Data->Line[Number] = (LINE_DATA*)malloc (sizeof(LINE_DATA));
  strncpy (Data->Line[Number]->Name, Name, 100);
  Data->Line[Number]->Name[99] = '\0';
  Data->Line[Number]->Mode  = Mode;
  Data->Line[Number]->Color = Color;
  Data->Line[Number]->len   = 0;
  Data->Line[Number]->Val   = NULL;
  Data->Line[Number]->Unit  = 0;
  Data->Line[Number]->Scale = 1;

  (Data->Number)++;

  PRO_END
  return Number;
}


dual MM_AddValue (PLOT_DATA *Data, int Number, float Val)
{
  int count;

  if (Data->Number < Number || Data->Line[Number] == NULL)
  {
    PRO0 ("Invalid line-number")
    return FALSE;
  }

  count = Data->Line[Number]->len;

  if (count % BLOCK_SIZE == 0)
    Data->Line[Number]->Val = realloc (Data->Line[Number]->Val, 
				       sizeof(float) * (count + 100));
  Data->Line[Number]->Val[count] = Val;
  (Data->Line[Number]->len)++;

  return TRUE;
}


void MM_FreeData (PLOT_DATA *Data)
{
  int count;

  if (Data == NULL)
    return;

  for (count = 0; count < Data->Number; ++count)
    if (Data->Line[count] != NULL)
    {
      if (Data->Line[count]->Val != NULL)
	free (Data->Line[count]->Val);
      free (Data->Line[count]);
    }
  free (Data);
}



