#include <libdlg.h>
#include <libhelp.h>

#include "mmGlobal.h"

#include <icons/bomb.xpm>
#include <icons/load.xpm>
#include <icons/save.xpm>
#include <icons/printer.xpm>
#include <icons/plot.xpm>
#include <icons/bar.xpm>
#include <icons/segment.xpm>
#include <icons/help.xpm>


/* ----------------------------------------------------------- */

static void PrgInit (Widget Work)
{
  PRO_START ("["__FUNCTION__"]...")  

  /* TODO:
     Parameter laden und einstellen
  */

  PRO_END
}


static void PrgLoad (void)
{
  PRO_START ("["__FUNCTION__"]...")

  PRO_END
}


static void PrgSave (void)
{
  PRO_START ("["__FUNCTION__"]...")

  PRO_END
}


static void PrgPrint (void)
{
  PRO_START ("["__FUNCTION__"]...")

  PRO_END
}


static void PrgInfo (void)
{
  PRO_START ("["__FUNCTION__"]...")

  DLGOpenTextDialog ("infoDlg", DlgINFO, 
		     "         Metex V0.1\n"
		     "Program to evaluate data from a\n"
		     "        Metex M-3850 D\n"
		     "          multimeter", 
		     1, "OK");

  PRO_END
}


void PrgExit (void)
{
  PRO_START ("["__FUNCTION__"]...")

  if (DLGOpenTextDialog("prgExit", DlgQUESTION,
			"Realy exit the Program ?", 2, "YES", "NO") == 2)
    PRO_ABORT ("Function aborted")

  PRGExitProgram ();
  PRO_END
}


static void View (int Mode)
{
  PRO_START ("["__FUNCTION__"]...\n")

  switch (Mode)
  {
    case  1 : MM_OpenPlotWindow ("metexPlot", Param);
              break;
    case  2 : MM_OpenBarWindow  ("metexBar", Param);
              break;
    default : MM_OpenSegmWindow ("metexSegement", Param);
  }

  PRO_END
}


static int MM_CheckDevice (DIALOG *Dlg, int BoxID)
{
  int Device;

  Device = DLGGetOMenu (Dlg, 11);
  DLGSetBoxActive (Dlg, 12, (Device == 4));

  return DlgCONFIRM;
}

static int MM_CheckTrigger (DIALOG *Dlg, int BoxID)
{
  int Trigger;

  Trigger = DLGGetOMenu (Dlg, 21);

  DLGSetBoxActive (Dlg, 22, (Trigger == 3));
  DLGSetBoxActive (Dlg, 23, (Trigger == 4));

  return DlgCONFIRM;
}

static void PrgParams (void)
{
  DIALOG *Dlg = NULL;

  PRO_START ("["__FUNCTION__"]...")

  Dlg = DLGNewDialog (0);
  DLGMakeCols (Dlg,  0, 2, DlgETCHED_IN, 10, 20);
  DLGMakeRows (Dlg, 10, 4, DlgNO_LINE,   11, 12, 13, 14);
  DLGMakeRows (Dlg, 20, 3, DlgNO_LINE,   21, 22, 23);

  DLGInsertOMenu (Dlg, 11, "device", 5, 
		  "/dev/ttyS0", "/dev/ttyS1", "/dev/ttyS2", "/dev/ttyS3", 
		  "USER", Param.Device);
  DLGInsertText  (Dlg, 12, "userDev", 16, Param.DevName, 16, 1);
  DLGInsertScale (Dlg, 13, "speed", 1.0, 60.0, Param.Speed, 0, DlgHORIZONTAL);
  DLGInsertBool  (Dlg, 14, "sync", Param.Sync);

  DLGInsertOMenu (Dlg, 21, "trigger", 5,
		  "immediate", "risingEdge", "fallingEdge", "limit", "delay",
		  Param.Trigger);
  DLGInsertDouble (Dlg, 22, "limit", Param.Value, 8, 4);
  DLGInsertScale  (Dlg, 23, "delay", 0.0, 3600.0, Param.Delay, 0, 
		                     DlgHORIZONTAL);

  DLGSetTitle (Dlg, 0, "metexParameter", DlgMIDDLE);
  DLGSetBorder (Dlg, 20, DlgETCHED_IN);

  DLGSetBoxActive (Dlg, 12, (Param.Device == 4));
  DLGSetBoxActive (Dlg, 22, (Param.Trigger == 3));
  DLGSetBoxActive (Dlg, 23, (Param.Trigger == 4));

  DLGSetFunction (Dlg, 11, MM_CheckDevice);
  DLGSetFunction (Dlg, 21, MM_CheckTrigger);
/* 
  Raster
  Schwellwert(e)
*/

  DLGOpenDialog (Dlg, "config", DlgNORMAL, NULL);
  if (DLGGetExitButton(Dlg) == DlgOK)
  {
    Param.Device = DLGGetOMenu (Dlg, 11);
    strcpy (Param.DevName, DLGGetText(Dlg, 12));
    Param.Speed = (int)DLGGetScale (Dlg, 13);
    Param.Sync = (dual)DLGGetOMenu (Dlg, 21);
    Param.Value = DLGGetDouble (Dlg, 22);
    Param.Delay = DLGGetScale (Dlg, 23);
  }
  DLGFreeDialog (Dlg);

  PRO_END
}


static void PrgConfig (void)
{
  PRO_START ("["__FUNCTION__"]...")

  PRO_END
}


void PrgHelp (void)
{
  PRO_START ("["__FUNCTION__"]...")

  HELPOpenHelpWin ("HELPWINDOW", "FILE:$HOME/project/help/xmetex/metex.hlp", 
		                 400, 400, NULL, 0);

  PRO_END
}

/* ================================================================= */

int main (int argc, char **argv)
{
  Widget Work;

  static MENU_ENTRY SystemMenu[] = 
  {
    ENTRY     ("load",  "",        "",   ' ', TRUE, PrgLoad,  NULL),
    ENTRY     ("save",  "",        "",   ' ', TRUE, PrgSave,  NULL),
    ENTRY     ("print", "",        "",   ' ', TRUE, PrgPrint, NULL),
    MENU_LINE (PrgETCHED_IN),
    ENTRY     ("info",  "",        "",   ' ', TRUE, PrgInfo,  NULL),
    MENU_LINE (PrgETCHED_IN),
    ENTRY     ("exit",  "",        "",   ' ', TRUE, PrgExit,  NULL)
  };

  static MENU_ENTRY WorkMenu[] =
  {
    ENTRY ("diagram",  "",      "",   ' ', TRUE, View,    1),
    ENTRY ("barChart", "",      "",   ' ', TRUE, View,    2),
    ENTRY ("segment",  "",      "",   ' ', TRUE, View,    3)
  };

  static MENU_ENTRY ConfigMenu[] =
  {
    ENTRY ("params",  "",       "",   ' ', TRUE, PrgParams, NULL),
    ENTRY ("config",  "",       "",   ' ', TRUE, PrgConfig, NULL)
  };

  static MENU_ENTRY HelpMenu[] =
  {
    ENTRY ("help", "<Key>F1", "F1", 'h', TRUE, PrgHelp, NULL)
  };

  static MENU_COLUMN MenuCols[] = 
  {
    FUNC_MENU ("system", 's', TRUE, SystemMenu),
    FUNC_MENU ("work",   'w', TRUE, WorkMenu),
    FUNC_MENU ("config", 'c', TRUE, ConfigMenu),
    HELP_MENU ("help",   'h', TRUE, HelpMenu)
  };

  static MENU_BAR Menu[] =
  {
    MAIN_MENU ("metexMenu", MenuCols)
  };

  PRGInitLib (argv[0], &argc, argv, NULL);

  PRGMakeToolBar (PrgTOP_TOOL);

  PRGAddToolIcon  (-1, -1, bomb_xpm,    PrgExit,  NULL, "Exit Program");
  PRGAddToolSpace (10);
  PRGAddToolIcon  (-1, -1, load_xpm,    PrgLoad,  NULL, "Load Data");
  PRGAddToolIcon  (-1, -1, save_xpm,    PrgSave,  NULL, "Save Data");
  PRGAddToolSpace (10);
  PRGAddToolIcon  (-1, -1, printer_xpm, PrgPrint, NULL, "Print Data");
  PRGAddToolSpace (10);
  PRGAddToolIcon  (-1, -1, plot_xpm,    View, (void*)1, "Diagram");
  PRGAddToolIcon  (-1, -1, bar_xpm,     View, (void*)2, "Bar Chart");
  PRGAddToolIcon  (-1, -1, segment_xpm, View, (void*)3, "Segment Display");
  PRGAddToolSpace (10);
  PRGAddToolIcon  (-1, -1, help_xpm,    PrgHelp,  NULL, "Help");

  Work = PRGCreateProgram (argv[0], Menu);

  PrgInit (Work);

  PRGStartProgram (NULL, NULL);

  exit (0);
  return 1;
}
